#!/usr/bin/perl
# 上の一文は状況に応じて書き換えてください。                                　　　　#
#-----------------------------------------------------------------------------------#
# 楽々おみくじ2.5　Ver 0.50α                                                       #
# Copyright (c) 1997-2006 うんにゃ                                                  #
# Presented by おみパラねっと                                                       #
# 		http://www.omi-para.net/omikuji/                                            #
#                                                                                   #
# [ライセンス及び利用条件]                                                          #
# このスクリプトは、クリエイティブ・コモンズの帰属 2.1 Japan                        #
# ライセンスの下でライセンスされています。この使用許諾条件を見るには、              #
# http://creativecommons.org/licenses/by/2.1/jp/ をチェックするか、                 #
# クリエイティブ･コモンズに郵便にてお問い合わせください。                           #
# 住所は：559 Nathan Abbott Way, Stanford, California 94305, USA です。             #
#                                                                                   #
# α版注意) このスクリプトはα版です。α版は最終的な仕様が未決定でドキュメントが    #
# 未整備であること、バグ修正が完成版に比べ不十分であること等を示します。            #
# α版のサポートは一切行いません。また本バージョンの設定ファイルの完成版での        #
# 互換性も保証できません。従ってある程度スキルのある方、トラブルに対処できる        #
# 方、チャレンジする気力のある方のみご利用ください。また本バージョンの再配布は      #
# 推奨しません                                                                      #
#                                                                                   #
#-----------------------------------------------------------------------------------#

### 基本設定 (「設定ファイル」で設定できない内容のみがこちらにあります。)###
## このスクリプトの相対パス（ファイル名を変更したときは必ずこれも変更してください。)
$script = "./rakuomi25.cgi";
## 設定ファイル
$deffile = "./omidef.cgi";

### ここから下は変更不要です。

### Main Routine ###
## advdataの読み込み
if ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}

@pairs = split(/&/,$buffer);
foreach (@pairs) {
	($name,$value) = split(/=/, $_);
	$value =~ tr/+/ /;
	$QUERY{$name} = $value;
}
$advdata = $QUERY{'advdata'};

## Errorlevel 決定
if( $pass eq $errpass ){ $errlevel = 1; }else{ $errlevel = 0; }

## 設定ファイルの呼び出し
require $deffile;
&def;

## カウンター関係の処理
if( $counter ){
	
	## ロック機構（「とほほのＷＷＷ入門」の物を使わせていただきました。）
	# ロック権を得る
	if( $c_lock ){
		foreach $i ( 1 .. 6 ) {
			if (mkdir("$c_lfile", 0755)) {
				# ロック成功。次の処理へ。
				last;
			} elsif ($i == 1) {
				# 10分以上古いロックファイルは削除する。
				($mtime) = (stat($c_lfile))[9];
				if ($mtime < time() - 600) {
					rmdir($c_lfile);
				}
			} elsif ($i < 6) {
				# ロック失敗。1秒待って再トライ。
				sleep(1);
			} else {
				# 何度やってもロック失敗。
				&error( 'ただいまアクセスが混んでいます。少し待って「再読込」してみて下さいm(__)m。');
			}
		}
	}
	
	# 途中で終了してもロックファイルが残らないようにする
	sub sigexit { rmdir($c_lfile); exit(0); }
	$SIG{'PIPE'} = $SIG{'INT'} = $SIG{'HUP'} = $SIG{'QUIT'} = $SIG{'TERM'} = "sigexit";
	
	## カウンターファイル読み込み
	open( CNT , $c_file ) || &error( "'$c_file'が見つかりません。" );
	$count = <CNT>;
	close( CNT );
	
	$count = 0 if $count eq '';
	
	$count++;
	
	# カウンターファイルへ書き込み
	open( CNT , ">$c_file" ) || &error( "'$c_file'に書き込みできません。" );
	print CNT $count;
	close( CNT );
	
	# ロック解放
	rmdir($c_lfile) if $c_lock;
	
	# 表示用カウンターの組み立て
	if( $c_disp ){
		@counts = split( // , $count );
		foreach ( @counts ){
			$COUNTER .= "<IMG Src=\"$c_dfolder$_.$c_dform\" Alt=\"$_\">";
		}
	}else{ $COUNTER = $count; }
	
}

## 乱数の初期化
# 時間を得る
@time = localtime(time);
$sec = $time[0]; $mday =$time[3];

# 初期化
srand ($mday);
for( $i=0 ; $i<$sec ; $i++){
	$dummy = rand;
}

## 同一運勢低減機能が働いているときの処理
if( $c_advomikuji && $advdata ne '' ){
	@fortune_back = split( // , $advdata );
}

## 各種運勢のデコード、決定
foreach $i ( 0 .. ($#fortune + 1) ){
	
	# 運勢のある行を行ごとに分解
	if( $i == 0 ){ @fortune_splits = split( /\n/ , $sougou ); 
	}else{ @fortune_splits = split( /\n/ , $fortune[$i] );}
	
	# 変数を初期化
	undef @fortune_values; undef @fortune_probs; undef @fortune_lines;
	$fortune_values[0] = 0; $fortune_probs[0] = 0; $fortune_lines[0] = 0;
	$prob_sum = 0;
	
	# コマンド行の読みとり
	for( $j=0 ; $j<=$#fortune_splits ; $j++ ){
		
		$line = $fortune_splits[$j];
		
		if ( $line ne '' && $line =~ /^\*/ ){
			# 先頭に"*"の含まれるのはコマンド文字列
			( $dummy,$f_val,$f_prob ) = split( /,/ , $line );
			push( @fortune_values , $f_val );
				# 各運勢の名前
			push( @fortune_probs , $f_prob );
				# 各運勢の選ばれる確率
			push( @fortune_lines , $j );
				# コマンド列のある行を示し、この次の行から、
				# 次のコマンド列までの間の行がその運勢の
				# コメント文になる。
			$prob_sum += $f_prob;
				# 各運勢での確率の総和（運勢決定時に必要）
		}
	}
	
	## 各運勢の決定
	
	# 変数初期化
	$probsum = 0; # $probsumは確率の和を示す。
	undef @probsums; # @probsumsは$probusumの配列。運勢決定時に使用
	
	for( $j=0 ; $j<=$#fortune_probs ; $j++){
		
		$prob = $fortune_probs[$j];
		
		# 変数の0項はダミーなので飛ばす。
		if ($prob == 0){ next; }
			
		# 同一運勢低減機能部
		if( $advdata ne '' && (( $c_advomikuji == 1 && $i == 0 ) || $c_advomikuji == 2 )){
			if( $fortune_back[$i] == $j ){
				$percent = $prob/$prob_sum;
				$prob *= (0.3*($percent**2) - 0.6*$percent + 0.4);
				# 前回の運勢と一致している場合は y = 0.3xx -0.6x + 0.4 の式から出る
				# 比率にまで確率を減らす。 元が100%の時は*0.4, 0%なら*0.1の
				# 二次曲線カーブ
			}
		}
		
		# 総合運に引きずられるサブ運勢
		if( $i && $o_influence && $c_advomikuji != 2 ){
			if( $j == $fortune_number[0] ){
				$percent = $prob/$prob_sum;
				$prob = $prob_sum * ( 0.3*($percent**2) + 0.7*$percent + 0.5 );
				# 総合運と一致しているときに y = 0.3xx + 0.7x + 0.5 の式の割合にまで
				# 確率を高める。元が0%なら50%, 100%なら100%のまま　（二次曲線）
				# うまく使うと、大吉の時のみ出現するサブ運の運勢などが作れる。
			}
		}
		
		# 決定した$probを$probsumへ加える
		$probsum += $prob;
		
		# 確率の配列へpush
		push( @probsums , $probsum );
		
	}
	
	# いよいよ運勢決定
	$desicive = rand( $probsums[$#probsums]);
	for( $k=0; $k<=$#probsums; $k++){
		if( $desicive <= $probsums[$k] ){
		$fortune_number[$i] = $k+1; last;
		}
	}
		
	# 運勢の名前とメッセージ
	# 運勢の名前
	if( $o_subdisp && $i ){
		foreach ( 1 .. $#probsums+1 ){
			if( $_ >= $fortune_number[$i] ){ $FORTUNE_NAMES[$i] = "★" . $FORTUNE_NAMES[$i]; }
			else{ $FORTUNE_NAMES[$i] = "☆" . $FORTUNE_NAMES[$i]; }
		}
	}else{ $FORTUNE_NAMES[$i] = $fortune_values[$fortune_number[$i]]; }
		
	# メッセージ
	$line_start = $fortune_lines[$fortune_number[$i]] + 1;
		if( $fortune_lines[$fortune_number[$i]+1] ){
			$line_end = $fortune_lines[$fortune_number[$i]+1] - 1;
		}else{
			$line_end = $#fortune_splits;
		}
	$line_range = $line_end - $line_start;
	$mes_number = int(rand ($line_range+1)) + $line_start;
	$mes_number = $line_end if $mes_number > $line_end;
	$FORTUNE_MESSAGES[$i] = $fortune_splits[ $mes_number ];
	
	
}
## 同一運勢低減機能オンの時はadvdataを作る
foreach ( @fortune_number ){
	$advdata_new .= "$_";
}

## ラッキーナンバーなどの決定
# ラッキーマテリアル・ラッキーナンバー

if( $l_material ){
	@materials = split( /,/ , $l_material );
	$MATERIAL = $materials[ rand( $#materials+1 ) ];
}	

if( $l_number ){
	@numbers = split( /,/ , $l_number );
	unless ( $numbers[0] >= $numbers[1] ){
		$num_range = $numbers[1] - $numbers[0];
		$NUMBER = int ( rand ($num_range+1)) + $numbers[0];
		$NUMBER = $numbers[1] if $NUMBER > $numbers[1];
	}
}

# 総合運へのラッキーカラー・ナンバー埋め込み
$FORTUNE_MESSAGES[0] =~ s/<--COL-->/$MATERIAL/ig;
$FORTUNE_MESSAGES[0] =~ s/<--NUM-->/$NUMBER/ig;

# 気の合う星座
if( $l_zodiac ){
	@zodiacs = split( /,/ , $l_zodiac );
	$zodiac = $zodiacs[ rand( $#zodiacs+1 ) ];
}	

$ZODIAC = $zodiac;

## 表示部

## わかりやすいように総合運の変数名を変更
$SOUGOU_NAME = $FORTUNE_NAMES[0];
$SOUGOU_MESSAGE = $FORTUNE_MESSAGES[0];

## 著作権表示１（この部分は削除禁止です。変更に当たっては「利用規程」に従ってください。）
$copyright1 = "楽々おみくじ2.5　Ver 0.50α";
$copyright2 = "うんにゃ";
$copyright3 = "http://www.omi-para.net/omikuji/";
## 著作権表示１　ここまで

# 出力用に変数を加工
&outstyle;


# おみくじを出力
print "Content-type: text/html; charset=utf-8\n";
print "Pragma: no-cache\n\n";

print <<"JSON";
{
	"Error": "0",
	"Generator": {
		"name": "$copyright1",
		"author": "$copyright2",
		"url": "$copyright3"
	},
	"Title" : "$TITLE",
	"Zodiac": "$ZODIAC",
	"Lnumber": "$NUMBER",
	"Lmaterial": "$MATERIAL",
	"Count": "$COUNTER",
	"AdvData": "$advdata_new",
	"ReSubmitWord": "$submit_word",
	"Fortune": {
		"main": {
			"unsei": "$SOUGOU_NAME",
			"message": "$SOUGOU_MESSAGE"
		},
		"subs": [
JSON
	
for ($i=1; $i<7; $i++){
	print <<"JSON";
			{
				"name": "$subfortune_name[$i]",
				"unsei": "$FORTUNE_NAMES[$i]",
				"message": "$FORTUNE_MESSAGES[$i]"
			},
JSON
}

print <<"FOOT";
		]
	}
}
FOOT

## 終了
exit(0);

### End Of Main Routine ###

## Error Routine ##
sub error{
my $reason  = shift;
	
print "Content-type: text/html; charset=utf-8\n";
print "Pragma: no-cache\n\n";

print <<"JSON";
{
	"Error": 1,
	"Message": "$reason"
}
JSON

# ロック解放
rmdir($c_lfile) if $c_lock && !$errlock;
	
exit(0);
}

### End Of Script ###